import 'dart:convert';

import 'package:http/http.dart' as http;
import 'package:wowit/methods.dart';

class SQLService {
 static Future<List<Map<String, List<Map<String, Object>>>>> execute(
      String query, Map<String, Object> params) async {
    var queryParameters = {
      'query': query,
    };
    if (params != null && params.length > 0) {
      queryParameters['jParam'] = jsonEncode(params);
    }
    List<Map<String, List<Map<String, Object>>>> retVal = [];
    try {
      print('SQLService.execute: ' + jsonEncode(queryParameters));
      var response =
          await http.post(Methods.getURI('/data/exec'), body: queryParameters);
      if (response.statusCode == 200) {
        print('SQLService.execute with reponse status code = ' +
            response.statusCode.toString());
        retVal = json.decode(response.body); //--> return data set
      }
    } catch (e) {
      print('SQLService.execute with exception:  ' + e.toString());
    }

    return retVal;
  }
}
